
%Function to calculate injected bus powers by the TCSC
function [TCSC_PQsend,TCSC_PQrec,PCAL,QCAL] = TCSCCalculatedpower(nbb,VA, VM,NTCSC,TCSCsend,TCSCrec,X,PCAL,QCAL)

for ii = 1:NTCSC
Bmm= - 1/X(ii);
Bmk= 1/X(ii);
for kk = 1:2
A = VA(TCSCsend(ii))-VA(TCSCrec(ii));
Pcal = VM(TCSCsend(ii))*VM(TCSCrec(ii))*Bmk*sin(A); 
Qcal = - VM(TCSCsend(ii) ) ^2*Bmm - VM(TCSCsend(ii))* VM(TCSCrec(ii))*Bmk*cos(A);
PCAL(TCSCsend(ii)) = PCAL(TCSCsend(ii)) + Pcal;
QCAL(TCSCsend(ii)) = QCAL(TCSCsend(ii)) + Qcal; 
if kk == 1
TCSC_PQsend(ii) = Pcal + j*Qcal;


else
TCSC_PQrec(ii) = Pcal + j*Qcal; 
end
send = TCSCsend(ii); 
TCSCsend(ii) = TCSCrec(ii); 
TCSCrec(ii) = send;
end
end