%Function to add the TCSC elements to Jacobian matrix
function [JAC] = TCSCJacobian(nbb,JAC,VM,VA,NTCSC,TCSCsend,TCSCrec,X,Flow,PSta,it);
for ii = 1:NTCSC
Bmm= -1/X(ii);
Bmk= 1/X(ii);
for kk = 1:2
A = VA(TCSCsend(ii))-VA(TCSCrec(ii));
Hkm = -VM(TCSCsend(ii))*VM(TCSCrec(ii))*Bmm*cos(A); 
Nkm = VM(TCSCsend(ii))*VM(TCSCrec(ii))*Bmm*sin(A);

JAC(2*TCSCsend(ii)-1,2*TCSCsend(ii)-1)= JAC(2*TCSCsend(ii)-1,2*TCSCsend(ii)-1) - VM(TCSCsend(ii))^2*Bmm;

JAC(2*TCSCsend(ii)-1, 2*TCSCrec(ii)-1) = JAC(2*TCSCsend(ii)-1, 2*TCSCrec(ii)-1) - Hkm;
JAC(2*TCSCsend(ii)-1, 2*TCSCrec(ii))   = JAC(2*TCSCsend(ii)-1, 2*TCSCrec(ii)) - Nkm;
JAC(2*TCSCsend(ii),   2*TCSCsend(ii))  = JAC(2*TCSCsend(ii),   2*TCSCsend(ii)) - VM(TCSCsend(ii))^2*Bmm;
JAC(2*TCSCsend(ii),   2*TCSCrec(ii)-1) = JAC(2*TCSCsend(ii),   2*TCSCrec(ii)-1) + Nkm;
JAC(2*TCSCsend(ii),   2*TCSCrec(ii))   = JAC(2*TCSCsend(ii),   2*TCSCrec(ii)) - Hkm; 

if it >1
if PSta(ii) == 1
if (Flow(ii) == 1 & kk == 1 ) | (Flow(ii) == -1 & kk == 2)
JAC(2*nbb + ii, 2*TCSCsend(ii)-1) = Hkm;
JAC(2*nbb + ii, 2*TCSCsend(ii)) = - Nkm;
JAC(2*nbb+ii, 2*TCSCrec(ii)-1) =-Hkm;
JAC(2*nbb + ii, 2*TCSCrec(ii)) = - Nkm;
JAC(2*nbb +ii, 2*nbb+ii) = + Nkm; 
end
JAC(2*TCSCsend(ii)-1, 2*nbb + ii) = Nkm;

JAC(2*TCSCsend(ii), 2*nbb + ii) = Hkm - VM(TCSCsend(ii))^2*Bmk;
else
    
JAC(2*nbb + ii, 2*nbb + ii ) =1;
end
end
send= TCSCsend(ii);
TCSCsend(ii) = TCSCrec(ii);
TCSCrec(ii) =send;
end
end