%Function to calculate power flows in TCSC controller
function [Ptcsc,Qtcsc] = TCSCPQflows(nbb,VA,VM,NTCSC,TCSCsend,TCSCrec,TCSCX);
for ii = 1:NTCSC
Bmk = 1/TCSCX(ii);
Bmm = -1/TCSCX(ii);
for kk = 1:2
A = VA(TCSCsend(ii)) - VA(TCSCrec(ii));
Ptcsc(ii,kk) = VM(TCSCsend(ii))*VM(TCSCrec(ii))*Bmk*sin(A); 
Qtcsc(ii,kk) = - VM(TCSCsend(ii))^2*Bmm - VM(TCSCsend(ii))*VM(TCSCrec(ii))*Bmk*cos(A);
send = TCSCsend(ii);
TCSCsend(ii) = TCSCrec(ii);
TCSCrec(ii) =send;

end
end