%Function to calculate injected bus powers
function [PCAL,QCAL] = CalculatedPowers(nbb,VM,VA,YR,YI) % Include all entries
PCAL = zeros(1,nbb); 
QCAL = zeros(1,nbb); 
for ii = 1: nbb
PSUM = 0;
QSUM = 0;

for jj = 1: nbb
PSUM = PSUM + VM(ii) * VM(jj)*(YR(ii,jj)*cos (VA(ii)-VA(jj)) + YI(ii,jj)*sin(VA(ii)-VA(jj)));
QSUM = QSUM + VM(ii) * VM(jj)*(YR(ii,jj)*sin(VA(ii)-VA(jj))- YI(ii,jj)*cos(VA(ii)-VA(jj)));
end
PCAL(ii) = PSUM;
QCAL(ii) = QSUM;
end
%End of functionCalculatePowers