%Function to calculate the net scheduled powers
function [PNET, QNET] = NetPowers(nbb,ngn,nld,genbus,loadbus,PGEN,QGEN, PLOAD,QLOAD)

% CALCULATE NET POWERS
PNET = zeros(1,nbb);
QNET = zeros(1,nbb);
for ii = 1: ngn
PNET(genbus(ii)) = PNET(genbus(ii)) + PGEN(ii); 
QNET(genbus(ii)) = QNET(genbus(ii)) + QGEN(ii); 
end

for ii = 1: nld
PNET(loadbus(ii)) = PNET(loadbus(ii)) - PLOAD(ii);
QNET(loadbus(ii)) = QNET(loadbus(ii)) - QLOAD(ii); 
end

%End function NetPowers