%Function to compute power mismatches
function [DPQ,DP,DQ,flag]=PowerMismatches(nbb,tol,bustype,flag,PNET,QNET,PCAL,QCAL);
% POWER MISMATCHES
nbb=6
nmax = 2*nbb

DPQ = zeros(1,nmax); 
DP=zeros(1,nbb); 
DQ=zeros(1,nbb); 
DQ = PNET - PCAL;
DQ= QNET - QCAL;

% To remove the active and reactive powers contributions of the slack
% bus and reactive power of all PV buses 

for ii = 1:nbb
    
if (bustype(ii) == 1 )
DP(ii) = 0;
DQ(ii) = 0;

elseif (bustype(ii) == 2)
DQ(ii) = 0;
end
end

% Re-arrange mismatch entries 
kk = 1 ;
for ii = 1 : nbb
DPQ(kk) = DP(ii);
DPQ(kk+1) = DQ(ii);
kk=kk+2;
end

% Check for convergence 
for ii = 1: nbb*2
if ( abs(DPQ)< tol )
flag =1;
end
end
%End function PowerMismatches